<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:06 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/packageDoc.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/packagedoc.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/packageDoc.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a PHP package. Provides access to information about the package,
<a name="line22"></a> * the package's comment and tags, and the classes in the package.
<a name="line23"></a> *
<a name="line24"></a> * @package PHPDoctor
<a name="line25"></a> */
<a name="line26"></a>class PackageDoc extends Doc
<a name="line27"></a>{
<a name="line28"></a>
<a name="line29"></a>	/** The classes in this package
<a name="line30"></a>	 *
<a name="line31"></a>	 * @var classDoc[]
<a name="line32"></a>	 */
<a name="line33"></a>	var $_classes = array();
<a name="line34"></a>
<a name="line35"></a>	/** The globals in this package
<a name="line36"></a>	 *
<a name="line37"></a>	 * @var fieldDoc[]
<a name="line38"></a>	 */
<a name="line39"></a>	var $_globals = array();
<a name="line40"></a>
<a name="line41"></a>	/** The functions in this package
<a name="line42"></a>	 *
<a name="line43"></a>	 * @var methodDoc[]
<a name="line44"></a>	 */
<a name="line45"></a>	var $_functions = array();
<a name="line46"></a>	
<a name="line47"></a>	/** Constructor
<a name="line48"></a>	 *
<a name="line49"></a>	 * @param str name
<a name="line50"></a>	 * @param RootDoc root
<a name="line51"></a>	 */
<a name="line52"></a>	function packageDoc($name, &$root)
<a name="line53"></a>    {
<a name="line54"></a>		$this->_name = $name;
<a name="line55"></a>		$this->_root =& $root;
<a name="line56"></a>		
<a name="line57"></a>		$phpdoctor =& $root->phpdoctor();
<a name="line58"></a>		
<a name="line59"></a>		// parse overview file
<a name="line60"></a>		$packageCommentDir = $phpdoctor->getOption('packageCommentDir');
<a name="line61"></a>        $packageCommentFilename = strtolower(str_replace('/', '.', $this->_name)).'.html';
<a name="line62"></a>		if (isset($packageCommentDir) && is_file($packageCommentDir.$packageCommentFilename)) {
<a name="line63"></a>			$overviewFile = $packageCommentDir.$packageCommentFilename;
<a name="line64"></a>		} else {
<a name="line65"></a>			$pos = strrpos(str_replace('\\', '/', $phpdoctor->_currentFilename), '/');
<a name="line66"></a>			if ($pos !== FALSE) {
<a name="line67"></a>				$overviewFile = substr($phpdoctor->_currentFilename, 0, $pos).'/package.html';
<a name="line68"></a>			} else {
<a name="line69"></a>				$overviewFile = $phpdoctor->sourcePath().$this->_name.'.html';
<a name="line70"></a>			}
<a name="line71"></a>		}
<a name="line72"></a>		if (is_file($overviewFile)) {
<a name="line73"></a>			$phpdoctor->message("\n".'Reading package overview file "'.$overviewFile.'".');
<a name="line74"></a>			if ($html = $this->getHTMLContents($overviewFile)) {
<a name="line75"></a>				$this->_data = $phpdoctor->processDocComment('/** '.$html.' */', $this->_root);
<a name="line76"></a>				$this->mergeData();
<a name="line77"></a>			}
<a name="line78"></a>		}
<a name="line79"></a>
<a name="line80"></a>	}
<a name="line81"></a>	
<a name="line82"></a>	/** Return the package path.
<a name="line83"></a>	 *
<a name="line84"></a>	 * @return str
<a name="line85"></a>	 */
<a name="line86"></a>	function asPath()
<a name="line87"></a>    {
<a name="line88"></a>		return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_name)));
<a name="line89"></a>	}
<a name="line90"></a>	
<a name="line91"></a>	/** Calculate the depth of this package from the root.
<a name="line92"></a>	 *
<a name="line93"></a>	 * @return int
<a name="line94"></a>	 */
<a name="line95"></a>	function depth()
<a name="line96"></a>    {
<a name="line97"></a>		$depth = substr_count($this->_name, '.');
<a name="line98"></a>		$depth += substr_count($this->_name, '\\');
<a name="line99"></a>		$depth += substr_count($this->_name, '/');
<a name="line100"></a>		return $depth;
<a name="line101"></a>	}
<a name="line102"></a>	
<a name="line103"></a>	/** Add a class to this package.
<a name="line104"></a>	 *
<a name="line105"></a>	 * @param ClassDoc class
<a name="line106"></a>	 */
<a name="line107"></a>	function addClass(&$class)
<a name="line108"></a>    {
<a name="line109"></a>        if (isset($this->_classes[$class->name()])) {
<a name="line110"></a>            $phpdoctor =& $this->_root->phpdoctor();
<a name="line111"></a>            echo "\n";
<a name="line112"></a>            $phpdoctor->warning('Found class '.$class->name().' again, overwriting previous version');
<a name="line113"></a>        }
<a name="line114"></a>		$this->_classes[$class->name()] =& $class;
<a name="line115"></a>	}
<a name="line116"></a>
<a name="line117"></a>	/** Add a global to this package.
<a name="line118"></a>	 *
<a name="line119"></a>	 * @param FieldDoc global
<a name="line120"></a>	 */
<a name="line121"></a>	function addGlobal(&$global)
<a name="line122"></a>    {
<a name="line123"></a>        if (!isset($this->_globals[$global->name()])) {
<a name="line124"></a>            $this->_globals[$global->name()] =& $global;
<a name="line125"></a>        }
<a name="line126"></a>	}
<a name="line127"></a>
<a name="line128"></a>	/** Add a function to this package.
<a name="line129"></a>	 *
<a name="line130"></a>	 * @param MethodDoc function
<a name="line131"></a>	 */
<a name="line132"></a>	function addFunction(&$function)
<a name="line133"></a>    {
<a name="line134"></a>        if (isset($this->_functions[$function->name()])) {
<a name="line135"></a>            $phpdoctor =& $this->_root->phpdoctor();
<a name="line136"></a>            echo "\n";
<a name="line137"></a>            $phpdoctor->warning('Found function '.$function->name().' again, overwriting previous version');
<a name="line138"></a>        }
<a name="line139"></a>		$this->_functions[$function->name()] =& $function;
<a name="line140"></a>	}
<a name="line141"></a>	
<a name="line142"></a>	/** Get all included classes (including exceptions and interfaces).
<a name="line143"></a>	 *
<a name="line144"></a>	 * @return ClassDoc[] An array of classes
<a name="line145"></a>	 */
<a name="line146"></a>	function &allClasses()
<a name="line147"></a>    {
<a name="line148"></a>		return $this->_classes;
<a name="line149"></a>	}
<a name="line150"></a>
<a name="line151"></a>	/** Get exceptions in this package.
<a name="line152"></a>	 *
<a name="line153"></a>	 * @return ClassDoc[] An array of exceptions
<a name="line154"></a>	 */
<a name="line155"></a>	function &exceptions()
<a name="line156"></a>    {
<a name="line157"></a>		$exceptions = NULL;
<a name="line158"></a>		foreach ($this->_classes as $name => $exception) {
<a name="line159"></a>			if ($exception->isException()) {
<a name="line160"></a>				$exceptions[$name] =& $this->_classes[$name];
<a name="line161"></a>			}
<a name="line162"></a>		}
<a name="line163"></a>		return $exceptions;
<a name="line164"></a>	}
<a name="line165"></a>
<a name="line166"></a>	/** Get interfaces in this package.
<a name="line167"></a>	 *
<a name="line168"></a>	 * @return ClassDoc[] An array of interfaces
<a name="line169"></a>	 */
<a name="line170"></a>	function &interfaces()
<a name="line171"></a>    {
<a name="line172"></a>		$interfaces = NULL;
<a name="line173"></a>		foreach ($this->_classes as $name => $interface) {
<a name="line174"></a>			if ($interface->isInterface()) {
<a name="line175"></a>				$interfaces[$name] =& $this->_classes[$name];
<a name="line176"></a>			}
<a name="line177"></a>		}
<a name="line178"></a>		return $interfaces;
<a name="line179"></a>	}
<a name="line180"></a>
<a name="line181"></a>	/** Get ordinary classes (excluding exceptions and interfaces) in this package.
<a name="line182"></a>	 *
<a name="line183"></a>	 * @return ClassDoc[] An array of classes
<a name="line184"></a>	 */
<a name="line185"></a>	function &ordinaryClasses()
<a name="line186"></a>    {
<a name="line187"></a>		$classes = NULL;
<a name="line188"></a>		foreach ($this->_classes as $name => $class) {
<a name="line189"></a>			if ($class->isOrdinaryClass()) {
<a name="line190"></a>				$classes[$name] =& $this->_classes[$name];
<a name="line191"></a>			}
<a name="line192"></a>		}
<a name="line193"></a>		return $classes;
<a name="line194"></a>	}
<a name="line195"></a>	
<a name="line196"></a>	/** Get globals in this package.
<a name="line197"></a>	 *
<a name="line198"></a>	 * @return FieldDoc[] An array of globals
<a name="line199"></a>	 */
<a name="line200"></a>	function &globals()
<a name="line201"></a>    {
<a name="line202"></a>		return $this->_globals;
<a name="line203"></a>	}
<a name="line204"></a>
<a name="line205"></a>	/** Get functions in this package.
<a name="line206"></a>	 *
<a name="line207"></a>	 * @return MethodDoc[] An array of functions
<a name="line208"></a>	 */
<a name="line209"></a>	function &functions()
<a name="line210"></a>    {
<a name="line211"></a>		return $this->_functions;
<a name="line212"></a>	}
<a name="line213"></a>
<a name="line214"></a>	/** Lookup for a class within this package.
<a name="line215"></a>	 *
<a name="line216"></a>	 * @param str className Name of the class to lookup
<a name="line217"></a>	 * @return ClassDoc A class
<a name="line218"></a>	 */
<a name="line219"></a>	function &findClass($className)
<a name="line220"></a>    {
<a name="line221"></a>        $return = NULL;
<a name="line222"></a>		if (isset($this->_classes[$className])) {
<a name="line223"></a>			$return =& $this->_classes[$className];
<a name="line224"></a>        }
<a name="line225"></a>        return $return;
<a name="line226"></a>	}
<a name="line227"></a>
<a name="line228"></a>}
<a name="line229"></a>
<a name="line230"></a>?>
<a name="line231"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/packagedoc.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>